#!/usr/bin/python
#
# sawmodel_clean_xml - Apply lab policy for selecting allowed peaks.
#
# Copyright (C) 2008-2009, William Trevor King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# The author may be contacted at <wking@drexel.edu> on the Internet, or
# write to Trevor King, Drexel University, Physics Dept., 3141 Chestnut St.,
# Philadelphia PA 19104, USA.

import sys
import sawmodel.fit_xml

def main():
    if len(sys.argv) <= 1:
        print """usage: sawmodel_clean_xml.py sawmodel.xml"

Where the unfolding files are of the format output be fit_xml.py
(e.g. the output of a sawmodel_mark.py run.)"""
        sys.exit(1)
    
    listfilename = sys.argv[1]
    unfoldModels = fit_xml.readUnfoldList(listfilename)
    unfolds = []
    for model in unfoldModels:
        model.load()
        model.fit()
        if len(model.WLClist) >= 2:
            fitUnfolds = model.getUnfolds()
            ln=len(fitUnfolds)
            for i,point in enumerate(fitUnfolds):
                pass
                #print "%d\t%.3g\t%.3g\t%s" % (ln-i-1, point[0], point[1], model.datafile)
            unfolds.extend(fitUnfolds)
        elif model.selected == True:
            print "%s selected but %d WLCs.  Dropping." % (model.datafile, len(model.WLClist))
            model.selected = False
        model.free()
    fit_xml.saveUnfoldList(unfoldModels, listfilename)
    return 0

if __name__ == "__main__":
    main()
