#!/usr/bin/python
#
# sawmodel_select2xml - convert output of sawmodel_select.py to input for
# sawmodel_mark.py
#
# Copyright (C) 2008-2009, William Trevor King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# The author may be contacted at <wking@drexel.edu> on the Internet, or
# write to Trevor King, Drexel University, Physics Dept., 3141 Chestnut St.,
# Philadelphia PA 19104, USA.
"""convert output of sawmodel_select.py to input for sawmodel_mark.py"""

import sys

def main():
    selectFilename = sys.argv[1]
    fitFilename = sys.argv[2]
    
    selectFile = file(selectFilename, 'r')
    fitFile = file(fitFilename, 'w')
    
    print >> fitFile, '<?xml version="1.0" encoding="UTF-8"?>'
    print >> fitFile, '<unfoldlist>'
    for line in selectFile.readlines() :
        line = line.split('\n')[0] # remove trailing endline
        fields = line.split('\t')
        assert len(fields) == 2, "Wrong # of fields in:\n%s" % line
        datafile = fields[0]
        selectInt = int(fields[1])
        if selectInt == 1 :
            select = True
        else :
            select = False
        if select :
            print >> fitFile, '  <unfold>'
            print >> fitFile, '    <datafile>\n      %s\n    </datafile>' % datafile
            print >> fitFile, '    <xScale>-1e-09</xScale>'
            print >> fitFile, '    <yScale>-1e-12</yScale>'
            print >> fitFile, '    <selected>%d</selected>' % selectInt
            print >> fitFile, '  </unfold>'
    print >> fitFile, '</unfoldlist>'
    
    fitFile.close()
    selectFile.close()
    return 0

if __name__ == "__main__" :
    main()
